## guitarix 0.34.0

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8

import sys, os, re, shutil
import Build, Utils, Options, Logs, Configure, Scripting
from Constants import HEXVERSION
from Configure import ConfigurationError
from TaskGen import feature
import wscript_dsp

# Waf version check, for global waf installs

try:
    from Constants import WAFVERSION
except:
    WAFVERSION='1.0.0'
if WAFVERSION[:3] != '1.5':
    print('Incompatible Waf, use 1.5')
    sys.exit (1)

# these variables are mandatory ('/' are converted automatically)
srcdir = '.'
blddir = 'build'
use_2to3 = True

# used by waf dist and waf build
VERSION='0.34.0'
APPNAME='guitarix'

good_faust_versions = ['0.9.58','0.9.65']

g_maxlen = 40 # maximum width of message for 2-column display


################################################################
# options defined for waf configure
################################################################

def set_options(opt):
    
    def add_enable_option (option, desc, group=None, disable=False):
        if group == None:
            group = opt
        option_ = option.replace ('-', '_')
        group.add_option ('--enable-' + option, action='store_true',
            default=False, help='Enable ' + desc, dest='enable_' + option_)
        group.add_option ('--disable-' + option, action='store_true',
            default=disable, help='Disable ' + desc, dest='disable_' + option_)

    opt.tool_options('gcov')
    opt.tool_options ('intltool')
    group = opt.add_option_group ('Localization and documentation', '')
    add_enable_option ('nls', 'native language support', group)

    opt.tool_options('compiler_cxx')
    comp = opt.get_option_group("--check-cxx-compiler")

    comp.add_option('--debug',
                    action='store_const',
                    default=False,
                    const=True,
                    help='set compiler flags for a debug build')

    comp.add_option('--cxxflags-release',
                    type='string',
                    default='-O3 -DNDEBUG',
                    dest='cxxflags_release',
                    help='additional C++ compiler flags for release version (not used if --debug) [Default: %default]')

    comp.add_option('--cxxflags-debug',
                    type='string',
                    default='-O2 -g -fstack-protector-all',
                    dest='cxxflags_debug',
                    help='additional C++ compiler flags for debug version (only used if --debug) [Default: %default]')

    comp.add_option('--cxxflags',
                    type='string',
                    default='-Wall', # -fomit-frame-pointer -ffast-math -fstrength-reduce -mmmx -mfpmath=sse -DUSE_XMMINTRIN -pipe
                    dest='cxxflags',
                    help='C++ base compiler flags [Default: %default]')

    comp.add_option('--disable-cxx11',
                    action='store_const',
                    default=False,
                    const=True,
                    help='deselect C++ compiler flag -std=c++11 [Default: False]')

    comp.add_option('--ldflags',
                    type='string',
                    default='', 
                    dest='ldflags',
                    help='C++ base linker flags ')

    comp.add_option('--optimization',
                    action='store_const',
                    default=False, #'-fomit-frame-pointer -ffast-math -fstrength-reduce -pipe',
                    const=True,
                    help='automatically select additional C++ compiler optimization flags for the current platform')

    comp.add_option('--no-desktop-update',
                    action='store_const',
                    default=False, #'-fomit-frame-pointer -ffast-math -fstrength-reduce -pipe',
                    const=True,
                    help='dont automatically update desktop database')


    opt.recurse('libgxw/gxw')
    opt.recurse('libgxwmm/gxwmm')

    comp = opt.add_option_group("Additional Library Options")

    comp.add_option('--includeresampler',
                    action='store_const',
                    default=False,
                    const=True,
                    help='build with included local zita-resample libary (Default NO)')

    comp.add_option('--includeconvolver',
                    action='store_const',
                    default=False,
                    const=True,
                    help='build with included local zita-convolver libary (Default NO)')

    comp.add_option('--convolver-ffmpeg',
                    action='store_const',
                    default=False,
                    const=True,
                    help='modified zita-convolver libary that uses ffmpeg instead of fftw3 for FFT (Default NO)')

    comp.add_option('--libdir',
                   type='string',
                   default='', 
                   dest='libdir',
                   help=('library install path '),
                   )

    faust = opt.add_option_group("Faust-Compiler")

    if len(good_faust_versions) == 1:
        faust_vers_str = good_faust_versions[0]
    else:
        faust_vers_str = "in [%s]" % ", ".join(good_faust_versions)

    faust.add_option('--faust',
                     action='store_const',
                     default=False,
                     const=True,
                     help=('use faust even if the installed version is not %s'
                           % faust_vers_str))

    faust.add_option('--no-faust',
                     action='store_const',
                     default=False,
                     const=True,
                     help="don't use faust, use the pre-built files in faust-generated")

    faust.add_option('--faust-float',
                     action='store_const',
                     default=False,
                     const=True,
                     help="build with faust, single precision")

    faust.add_option('--faust-vectorize',
                     action='store_const',
                     default=False,
                     const=True,
                     help="call faust with --vectorize")

    faust.add_option('--faust-vectorize-float',
                     action='store_const',
                     default=False,
                     const=True,
                     help=("call faust with --vectorize for sources built"
                           "in single (float) precision"))

    faust.add_option('--faust-options', help="additional faust options")

    ladspa = opt.add_option_group("LADSPA Options (installing ladspa modules)")

    ladspa.add_option('--no-ladspa',
                    action='store_const',
                    default=False,
                    const=True,
                    help="don't build ladspa plugins (Default yes)")

    ladspa.add_option('--no-new-ladspa',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("don't build with new ladspa plugins (Default yes)"))


    ladspa.add_option('--ladspadir',
                    type='string',
                    help='LADSPA plugin directory [Default: <prefix>/lib/ladspa]')

    lv2 = opt.add_option_group("LV2 Options (installing LV2 modules)")

    lv2.add_option('--lv2dir',
                    type='string',
                    help='LV2 plugin directory [Default: <prefix>/lib/lv2]')

    lv2.add_option('--no-lv2',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("don't build new lv2 plugins (Default no)"))

    lv2.add_option('--no-lv2-gui',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("don't build lv2 plugin GUI's (Default no)"))

    lv2.add_option('--lv2-only',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("build only the lv2 plugins (Default no)"))

    lv2.add_option('--disable-sse',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("disable SSE for lv2 plugins (ARM)"))


    opt.recurse('pygxw')
    opt.recurse('glade-gxw')

    opt.tool_options('compiler_cc') # for pygxw and glade-gxw

    opt.add_option('--dist-tree',
                   type='string',
                   dest='dist_tree',
                   help=("option for 'dist' command: git tree-ish to build"
                         " the archive from [Default: %s]" % 'V%s' % VERSION))

    opt.sub_options('src/gx_head');


################################################################
# waf configure
################################################################

################################################################
# configuration display helper functions
#

def print_msg(msg, nl=True):
    if HEXVERSION > 0x10500:
        s = sys.stderr
    else:
        s = sys.stdout
    if nl:
        t = "\n"
    else:
        t = " "
    s.write(msg+t)

# a bit of waf display formatting
def display_msg(msg, status = None, color = None):
    sr = msg
    global g_maxlen
    g_maxlen = max(g_maxlen, len(msg))
    if status:
        print_msg("%s :" % msg.ljust(g_maxlen),False)
        Utils.pprint(color, status)
    else:
        print_msg("%s" % msg.ljust(g_maxlen))

def error_msg(msg):
    Utils.pprint('RED', msg)

def display_feature(msg, build):
    if build:
        display_msg(msg, "yes", 'CYAN')
    else:
        display_msg(msg, "no", 'YELLOW')

################################################################
# configuration utility functions
#

def option_enabled (option):
    if getattr (Options.options, 'enable_' + option):
        return True
    if getattr (Options.options, 'disable_' + option):
        return False
    return True

def append_optimization_flags(cxxflags):
    cpu_model = None
    x86_flags = None
    try:
        for line in open("/proc/cpuinfo"):
            if cpu_model is None:
                if line.startswith("model name"):
                    cpu_model = line.split(":",1)[1].strip()
            elif x86_flags is None:
                if line.startswith("flags"):
                    x86_flags = line.split(":",1)[1].strip()
            else:
                break
    except IOError:
        pass
    if cpu_model is None or x86_flags is None:
        display_msg("Checking CPU Architecture",
                    "cpu model not found in /proc/cpuinfo",
                    "YELLOW")
        return None
    model = cpu_model.split()
    arch = os.uname()[4]
    if "AMD" in model and "x86_64" in arch:
        cxxflags.append ("-march=k8")
    elif "AMD" in model and "Sempron(tm)" in model:
        cxxflags.append ("-march=native")
    elif "Geode" in model :
        cxxflags.append ("-march=geode")
    elif "Core" in model and "x86_64" in arch:
        cxxflags.append ("-march=core2")
    elif "i386" in arch:
        cxxflags.append ("-march=i386")
    elif "i486" in arch:
        cxxflags.append ("-march=i486")
    elif "i586" in arch:
        cxxflags.append ("-march=i586")
    elif "i686" in arch:
        cxxflags.append ("-march=i686")
    else:
        cxxflags.append ("-march=native")

    if "mmx" in x86_flags:
        cxxflags.append ("-mmmx")
    if "3dnow" in x86_flags:
        cxxflags.append ("-m3dnow")

    if "sse5" in x86_flags:
        cxxflags.append ("-msse5")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4_2" in x86_flags:
        cxxflags.append ("-msse4.2")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4_1" in x86_flags:
        cxxflags.append ("-msse4.1")
        cxxflags.append ("-mfpmath=sse")
    elif "ssse3" in x86_flags:
        cxxflags.append ("-mssse3")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4a" in x86_flags:
        cxxflags.append ("-msse4a")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4" in x86_flags:
        cxxflags.append ("-msse4")

=== rcstyles/wscript ===
#!/usr/bin/env python
# encoding: utf-8

gxstyle_files = [
    'gx12b.png',
    'gx14b.png',
    'gx18.png',
    'gxhead.png',
    'gx_green18.png',
    'gx_black18.png',
    'gx_gree18.png',
    'gx_green1.jpg',
    'gx_green2.jpg',
    'gx_green3.jpg',
    'gx_head_gx1-alloy.rc',
    'gx_head_gx2-emerald.rc',
    'gx_head_gx3-dezert.rc',
    'gx_head_gx4-black.rc',
    'gx_head_gx5-gree.rc',
    'gx_head_gx6-blue.rc',
    'gx_head_gx7-blues.rc',
    'gx_head_gx8-dark.rc',
    'gx_head_gx9-flat.rc',
    'gx_head_gx9-grass.rc',
    'gx-dezert_18.png',
    'gx_dezert_12b.png',
    'gx_dezert_14b.png',
    'common.rc',
    'clear.rc',
    'knob9.png',
    'tactile_knob_large_151f.png',
    'tactile_knob_small_99f.png',
    'tactile_knob_medium_151f.png',
    'nk-knob.png',
    'nk-knob-small.png',
    'nk-knob-middle.png',
    'tactile_switchit_off.png',
    'tactile_switchit_on.png',
    'tactile_wheel_101f.png',
    'tactile_h_wheel_101f.png',
    'tactile_backlit_switchit_off.png',
    'tactile_backlit_switchit_on.png',
    'smallknob9.png',
    'mittleknob9.png',
    'cairo1.jpg',
    'cairo2.jpg',
    'cairo3.jpg',
    'black1.png',
    'black2.png',
    'gx_steal.png',
    'gx_dark.png',
    'stereo.png',
    'bypass.svg',
    'factory.png',
    'mute.svg',
    'readonly.png',
    'scratch.png',
    'versiondiff.png',
    'playhead.png',
    'simplelevelslider.png',
    'menu_green1.jpg',
    'menu1.jpg',
    'flat1.png',
    'flat2.png',
    'flat3.png',
    'grass1.png',
    'grass2.png',
    'grass3.png',
    'menu1.png',
    'flatmenu.png',
    ]

def configure(conf):
    pass

def build(bld):
    bld.install_files(bld.env['GX_STYLE_DIR'], gxstyle_files, chmod=0o644)

=== glade-gxw/glade-icons/wscript ===
# -*- python -*-
# -*- coding: utf-8 -*-

import os.path

def build(bld):
    icon_files = [
        "gxbigknob.png",
        "gxiredit.png",
        "gxselector.png",
        "gxsmallknob.png",
        "gxmediumknob.png",
        "gxpaintbox.png",
        "gxtoggleimage.png",
        "gxfastmeter.png",
        "gxhslider.png",
        "gxradiobutton.png",
        "gxtuner.png",
        "gxwaveview.png",
        "gxminislider.png",
        "gxswitch.png",
        "gxwheel.png",
        "gxeqslider.png",
        "gxvslider.png",
        "gxvaluedisplay.png",
        "gxmeterscale.png",
        "gxportdisplay.png",
        ]
    j = os.path.join
    icon_dir = os.path.normpath(j(bld.env['SHAREDIR'], 'guitarix','icons'))
    for d in "16x16", "22x22":
        path = j("hicolor", d, "actions")
        dest = j(bld.env['GX_ICON_DIR'], path)
        instfiles = [j(path, "widget-gxwidgets-" + v) for v in icon_files]
        bld.install_files(dest, instfiles, chmod=0644)

=== libgxw/gxw/wscript ===
# -*- python -*-
# -*- coding: utf-8 -*-

import Logs, Utils, Configure, Options, os.path

def set_options(opt):
    pass

def configure(conf):
    if conf.env["GX_LIB_SHARED"] or conf.env["GXW_SHARED"]:
        conf.check_tool("libtool")

def img2c(task):
    mkname = lambda v: "pb_" + os.path.splitext(os.path.basename(str(v)))[0]
    sources = " ".join(["'%s' '%s'" % (mkname(v), v.srcpath(task.env)) for v in task.inputs])
    dst = task.outputs[0].bldpath(task.env)
    cmd = ("gdk-pixbuf-csource --raw --build-list %s > %s" % (sources, dst))
    Logs.debug("runner: system command -> %s" % cmd)
    return Utils.exec_command(cmd, shell=True)

def build_stock_images(bld):
    images = [
        "button_off.png",
        "button_on.png",
        "eqslider.png",
        "levelslider.png",
        "knob1.png",
        "led_off.png",
        "led_on.png",
        "minislider.png",
        "minitoggle_off.png",
        "minitoggle_on.png",
        "hslider.png",
        "smallknob1.png",
        "switchit_off.png",
        "switchit_on.png",
        "switch_off.png",
        "switch_on.png",
        "pbutton_on.png",
        "pbutton_off.png",
        "rbutton_on.png",
        "rbutton_off.png",
        "prbutton_on.png",
        "prbutton_off.png",
        "fbutton_on.png",
        "fbutton_off.png",
        "vslider.png",
        "wheel_back.png",
        "wheel_vertical_back.png",
        "wheel_fringe.png",
        "wheel_pointer.png",
        "tribe.png",
        "guitar.png",
        "gxhead.png",
        "gxhead_face.png",
        "gxplate.png",
        "gxplate2.png",
        "gxplate3.png",
        "portdisplay.png",
        "texture_cab.png",
        "guitarix.png",
        "screw.png",
        "knob_medium.png",
        "amp21.png"
        ]

    bld(name = "img2c",
        target = "gximages.cc",
        rule = img2c,
        source = ["../icons/"+v for v in images],
        )
    bld.add_group()

def build(bld):
    sources = [
        'gxinit.cpp',
        'GxFastMeter.cpp',
        'GxWaveView.cpp',
        'GxTuner.cpp',
        'GxRegler.cpp',
        'GxSelector.cpp',
        'GxSwitch.cpp',
        'GxToggleImage.cpp',
        'GxControlParameter.cpp',
        'GxIREdit.cpp',
        'GxRadioButton.cpp',
        'GxWheel.cpp',
        'GxWheelVertical.cpp',
        'GxKnob.cpp',
        'GxBigKnob.cpp',
        'GxSmallKnob.cpp',
        'GxSmallKnobR.cpp',
        'GxHSlider.cpp',
        'GxMiniSlider.cpp',
        'GxVSlider.cpp',
        'GxEQSlider.cpp',
        'GxLevelSlider.cpp',
        'GxPaintBox.cpp',
        'GxMeterScale.cpp',
        'GxGradient.cpp',
        'GxValueDisplay.cpp',
        'GxSimpleValueDisplay.cpp',
        'GxRackTuner.cpp',
        'GxPortDisplay.cpp',
        ]
    build_stock_images(bld)
    if bld.env["GX_LIB_STATIC"]:
        # static library
        prog = bld(
            features = ['cxx', 'cstaticlib'],
            includes = ['.'],
            #cxxflags = ['-fPIC'],
            source = sources,
            uselib = ['GTHREAD', 'GTK2'],
            target = 'gxw',
            chmod=0o755,
            )
    if bld.env["GX_LIB_SHARED"] or bld.env["GXW_SHARED"]:
        # shared library
        prog = bld(
            features = ['cxx', 'cshlib'],
            includes = ['.'],
            source = sources,
            uselib = ['GTHREAD', 'GTK2'],
            target = 'gxw',
            chmod=0o755,
            )
        if bld.env["GX_LIB_SHARED"] or bld.env["GXW_SHARED_INSTALL"]:
            prog.features.append('libtool')
            prog.type = 'cshlib'
            prog.vnum = "0.1"
        else:
            prog.install_path = None

=== src/LV2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import os, re

def sub_file(src_fname, dst_fname, lst):

    f = open(src_fname, 'rU')
    txt = f.read()
    f.close()

    for (key, val) in lst:
        re_pat = re.compile(key, re.M)
        txt = re_pat.sub(val, txt)

    f = open(dst_fname, 'w')
    f.write(txt)
    f.close()

def append_sse_flags():
    cpu_model = None
    x86_flags = None
    try:
        for line in open("/proc/cpuinfo"):
            if cpu_model is None:
                if line.startswith("model name"):
                    cpu_model = line.split(":",1)[1].strip()
            elif x86_flags is None:
                if line.startswith("flags"):
                    x86_flags = line.split(":",1)[1].strip()
            else:
                break
    except IOError:
        pass
    if cpu_model is None or x86_flags is None:
        return False
    model = cpu_model.split()
    arch = os.uname()[4]

    if "sse2" in x86_flags:
        return True
    else:
        return False

def dirlist():
    subdirs = [
        'gx_amp.lv2',
        'gx_amp_stereo.lv2',
        'gxautowah.lv2',
        'gxbooster.lv2',
        'gx_chorus.lv2',
        'gx_compressor.lv2',
        'gx_delay.lv2',
        'gxechocat.lv2',
        'gx_echo.lv2',
        'gx_expander.lv2',
        'gx_flanger.lv2',
        'gxmetal_amp.lv2',
        'gxmetal_head.lv2',
        'gx_phaser.lv2',
        #'gxpreamp.lv2',
        #'gxpreamp.lv2/StereoAmp',
        'gx_redeye.lv2',
        'gx_reverb.lv2',
        'gx_studiopre.lv2',
        'gx_studiopre_st.lv2',
        'gxtilttone.lv2',
        'gx_tremolo.lv2',
        'gxts9.lv2',
        'gxtubedelay.lv2',
        'gxtubetremelo.lv2',
        'gxtubevibrato.lv2',
        'gxtuner.lv2',
        'gx_zita_rev1.lv2',
        'gx_mbdistortion.lv2',
        'gx_mbdelay.lv2',
        'gx_mbecho.lv2',
        'gx_mbcompressor.lv2',
        'gx_fuzz.lv2',
        'gx_graphiceq.lv2',
        'gx_duck_delay.lv2',
        'gx_duck_delay_st.lv2',
        'gx_barkgraphiceq.lv2',
        'gx_detune.lv2',
        'gx_shimmizita.lv2',
        'gx_switched_tremolo.lv2',
        'gx_room_simulator.lv2',
        'gx_digital_delay.lv2',
        'gx_digital_delay_st.lv2',
        'gx_livelooper.lv2',
        'gx_mbreverb.lv2',
        'gx_jcm800pre.lv2',
        'gx_jcm800pre_st.lv2',
        'gx_cabinet.lv2',
        'gx_vibe.lv2',
        'gx_fuzzface.lv2',
        'gx_fuzzfacefm.lv2',
        'gx_hfb.lv2',
        'gx_hornet.lv2',
        'gx_muff.lv2',
        'gx_scream.lv2',
        'gx_susta.lv2',
        'gx_cstb.lv2',
        'gx_fumaster.lv2',
        'gx_oc_2.lv2',
        'gx_mole.lv2',
        'gx_rangem.lv2',
        'gx_hogsfoot.lv2',
        'gx_wah.lv2',
        ]

    return subdirs

def configure(conf):
    if not conf.env['NOSSE']:
        conf.env['SSE2'] = append_sse_flags()
    pa = '.so'

    for x in dirlist():
        conf.sub_config('%s' % x);
        sub_file('./src/LV2/%s/manifest.ttl.in' % x, './src/LV2/%s/manifest.ttl' % x, (('@LIB_EXT@', '%s' % pa), ))

def build(bld):
    # faust folder keep out of dirlist
    bld.add_subdirs('faust')
    bld.add_subdirs(dirlist())
    
    if not bld.env['NOLV2GUI']:
        gx_ampstyledir = bld.path.find_dir( 'GUI' ) ;
        bld.install_files(bld.env['GX_LV2_STYLE_DIR'], gx_ampstyledir.ant_glob('**/*.png'),cwd=gx_ampstyledir, chmod=0o644, relative_trick=True)
        bld.install_files(bld.env['GX_LV2_STYLE_DIR'], gx_ampstyledir.ant_glob('**/*.rc'),cwd=gx_ampstyledir, chmod=0o644, relative_trick=True)

=== src/gx_head/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import sys, wscript_helper
import Task, Utils, Options, Logs, os, shutil
from TaskGen import extension

def set_options(opt):
    guitarix_prog = opt.add_option_group("Guitarix Program Options")
    guitarix_prog.add_option(
        '--no-avahi', action='store_const', default=False, const=True,
        help=('Do not build with avahi support for automatic discovery of'
              ' / connection to Guitarix server instances  [Default: no]'))
    guitarix_prog.add_option(
        '--no-bluez', action='store_const', default=False, const=True,
        help=('Do not build with bluez support for remote'
              ' / connection to Guitarix server instances  [Default: no]'))

def configure(conf):
    if not Options.options.no_avahi:
        conf.check_cfg(package='avahi-gobject', args='--cflags --libs', uselib_store='AVAHI_GOBJECT', mandatory=1)
        conf.check_cfg(package='avahi-glib', args='--cflags --libs', uselib_store='AVAHI_GLIB', mandatory=1)
        conf.check_cfg(package='avahi-client', args='--cflags --libs', uselib_store='AVAHI_CLIENT', mandatory=1)
        conf.define("HAVE_AVAHI", 1)
    if not Options.options.no_bluez:
        conf.check_cfg(package='bluez', args='--cflags --libs', uselib_store='BLUEZ', mandatory=0)

def gperf2cc(task):
    out_c = task.outputs[0].bldpath(task.env)
    out_h = task.outputs[1].bldpath(task.env)
    basename = os.path.splitext(
        os.path.basename(task.inputs[0].srcpath(task.env)))[0]
    srcdir = task.inputs[0].parent.srcpath(task.env)
    if task.env["HAVE_GPERF"]:
        cmd = [task.proc,
               task.inputs[0].srcpath(task.env),
               out_c,
               out_h,
               ]
        Logs.debug("runner: system command -> %s" % cmd)
        ret = Utils.exec_command(cmd, shell=False)
        shutil.copy2(out_c, os.path.join(srcdir, basename+"-generated.cc"))
        shutil.copy2(out_h, os.path.join(srcdir, basename+"-generated.h"))
        return ret
    else:
        shutil.copy2(os.path.join(srcdir, basename+"-generated.cc"), out_c)
        shutil.copy2(os.path.join(srcdir, basename+"-generated.h"), out_h)
        return 0

Task.task_type_from_func(
    'gperf',
    gperf2cc,
    color='BLUE',
    before='cc cxx',
    )

@extension('.gperf_tmpl')
def process_gperf_tmpl(self, node):
    cc_node = node.change_ext('.cc')
    h_node = node.change_ext('.h')
    task = self.create_task('gperf', [node], [cc_node, h_node])
    task.proc = "../tools/make_jsonrpc_methods"
    self.bld.add_manual_dependency(node,self.bld.bldnode.find_resource(task.proc))

def build(bld):
    sources_engine = [
        './engine/gx_logging.cpp',
        './engine/gx_pluginloader.cpp',
        './engine/ladspaplugin.cpp',
        './engine/ladspaback.cpp',
        './engine/tunerswitcher.cpp',
        './engine/jsonrpc.cpp',
        './engine/gx_jack.cpp',
        './engine/gx_preset.cpp',
        './engine/gx_json.cpp',
        './engine/gx_faust_plugins.cpp',
        './engine/gx_internal_plugins.cpp',
        './engine/gx_internal_ui_plugins.cpp',
        './engine/gx_midi_plugin.cpp',
        './engine/gx_engine_audio.cpp',
        './engine/gx_paramtable.cpp',
        './engine/gx_pitch_tracker.cpp',
        './engine/gx_convolver.cpp',
        './engine/gx_resampler.cpp',
        './engine/gx_system.cpp',
        './engine/gx_engine.cpp',
        './engine/gx_engine_midi.cpp',
        './engine/jsonrpc_methods.gperf_tmpl',
        ]

    sources_gui = [
        './gui/machine.cpp',
        './gui/ladspalist.cpp',
        './gui/gx_stackbox_builder.cpp',
        './gui/gx_main_window.cpp',
        './gui/liveplay.cpp',
        './gui/rack.cpp',
        './gui/gx_preset_window.cpp',
        './gui/gx_jack_options.cpp',
        './gui/gx_ui_builder.cpp',
        './gui/gx_gui_helpers.cpp',
        './gui/gx_child_process.cpp',
        './gui/gx_main_midi.cpp',
        './gui/gx_jconv_settings.cpp',
        './gui/gxw_mm_controllers.cpp',
        './gui/gx_main_boxes.cpp',
        './gui/gx_mono_rack_builder.cpp',
        './gui/gx_stereo_rack_builder.cpp',
        './gui/gx_cairo_callbacks.cpp',
        './gui/gx_portmap.cpp',
        './gui/gx_main.cpp',
        ]

    builder_files = [
        './builder/midi.glade',
        './builder/ports.glade',
        './builder/iredit.glade',
        './builder/iredit_mono.glade',
        './builder/jackstarter.glade',
        './builder/mainpanel.glade',
        './builder/ladspaliste.glade',
        './builder/crybaby_ui.glade',
        './builder/gx_distortion_ui.glade',
        './builder/amp.tonestack_ui.glade',
        './builder/tremolo_ui.glade',
        './builder/pluginpreset_inputwindow.glade',
        './builder/pluginpreset_listwindow.glade',
        './builder/selectinstance.glade',
        './builder/menudef.xml',
        './builder/accels_rc',
        ]

    if bld.env["HAVE_AVAHI"]:
        sources_gui.append("gui/avahi_discover.cpp")
        sources_engine.append("engine/avahi_register.cpp")
    sources = sources_engine + sources_gui
    incl = ['.','./engine','../..','..','../headers','../../libgxwmm','../../libgxw'] # need ".." for config.h
    libpath = []
    lib = []
    if sys.platform.startswith("linux"):
        lib.append('dl')
    uselib = ['JACK', 'SNDFILE', 'GTHREAD', 'GMODULE_EXPORT', 'WEBKIT',
              'GTK2', 'GTKMM', 'GIOMM', 'FFTW3', 'LRDF', 'LILV', 'BOOST_SYSTEM']
    if bld.env["HAVE_AVAHI"]:
        uselib += ['AVAHI_GOBJECT', 'AVAHI_GLIB', 'AVAHI_CLIENT']
    if bld.env["HAVE_BLUEZ"]:
        uselib.append('BLUEZ')
    uselib_local = []
    wscript_helper.add_zita_convolver(bld, uselib, sources, incl)
    wscript_helper.add_zita_resampler(bld, uselib, sources, incl)
    if bld.env["HAVE_PLUGINLIB"]:
        uselib_local += ["plugins"]
    if bld.env["GX_LIB_SHARED"]:
        lib += ['gxwmm','gxw']
        libpath += [bld.path.find_dir("../../libgxw/gxw").bldpath(bld.env),
                    bld.path.find_dir("../../libgxwmm/gxwmm").bldpath(bld.env)]
    else:
        uselib_local += ['gxwmm','gxw']
    ldscript = bld.path.find_resource('guitarix.lds')
    mapfile = bld.path.find_or_declare("guitarix.map")
    task = bld(features = 'cxx cprogram',
        includes = incl,
        obj_ext  = '.o',
        source = sources,
        lib = lib,
        uselib = uselib,
        uselib_local = uselib_local,
        libpath = libpath,
        target = bld.env['BIN_NAME'],
        chmod = 0o755,
        install_path = bld.env['BINDIR'],
        ldflags = ['-Wl,%s,-Map=%s' % (ldscript.srcpath(),mapfile.bldpath(bld.env))],
        )
    bld.add_manual_dependency(bld.path.find_or_declare(task.target), ldscript)
    bld.install_files(bld.env['GX_BUILDER_DIR'], builder_files, chmod=0o644)

=== src/ladspa/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import sys, os, TaskGen, ctypes, wscript_helper

def configure(conf):
    pass

@TaskGen.feature('test_loadable')
def test_loadable(self):
    def link_and_test(lib=self.link_task.outputs[0].bldpath(self.env), link=self.link_task.run):
        link()
        try:
            ctypes.cdll.LoadLibrary(lib)
        except Exception as e:
            raise RuntimeError("LADSPA load test failed: %s" % e)
    self.link_task.run = link_and_test

def build(bld):
    bsources = [
        '../gx_head/engine/gx_json.cpp',
        '../gx_head/engine/gx_faust_plugins.cpp',
        '../gx_head/engine/gx_internal_plugins.cpp',
        '../gx_head/engine/gx_engine_audio.cpp',
        '../gx_head/engine/gx_paramtable.cpp',
        '../gx_head/engine/gx_convolver.cpp',
        '../gx_head/engine/gx_resampler.cpp',
        '../gx_head/engine/gx_system.cpp',
        '../gx_head/engine/gx_logging.cpp',
        '../gx_head/engine/gx_pluginloader.cpp',
        ## lib can't be used (-fPIC)
        '../plugins/zita_rev1.cc',
        '../plugins/vibe.cc',
        '../plugins/abgate.cc',
        '../plugins/ts9sim.cc',
        '../plugins/flanger_gx.cc',
        '../plugins/mbc.cc',
        '../plugins/mbcs.cc',
        '../plugins/mbd.cc',
        '../plugins/mbe.cc',
        '../plugins/mbdel.cc',
        '../plugins/mbchor.cc',
        '../plugins/reversedelay.cc',
        '../plugins/gcb_95.cc',
        '../plugins/hfb.cc',
        '../plugins/hogsfoot.cc',
        '../plugins/lpbboost.cc',
        '../plugins/rolandwah.cc',
    ]
    
    src = ['ladspa_guitarix.cpp'] + bsources
    incl = ['../headers', '..','../gx_head/engine','../plugins','../../libgxwmm','../../libgxw']
    lib = []
    if sys.platform.startswith("linux"):
        lib.append('dl')
    uselib = ['JACK', 'SNDFILE', 'GTHREAD', 'GMODULE_EXPORT',
              'GLIBMM', 'GIOMM', 'FFTW3', 'BOOST_SYSTEM', 'LILV']
    wscript_helper.add_zita_convolver(bld, uselib, src, incl)
    wscript_helper.add_zita_resampler(bld, uselib, src, incl)
    ladspa_plugin = bld(
        #features='cxx cprogram',  ## for debugging
        features='cxx cshlib test_loadable',
        includes = incl,
        lib = lib,
        uselib = uselib,
        #uselib_local = ["plugins"], ## needs -fPIC
        cxxflags = ["-fvisibility=hidden"],
        defines = ["LADSPA_SO"],
        target   = 'ladspa_guitarix',
        source   = src,
        install_path = '${LADSPADIR}',
        chmod = 0o755,
        )
    ladspa_plugin.env['shlib_PATTERN'] = '%s.so'
    bld.install_files('${SHAREDIR}/ladspa/rdf', 'guitarix_amp.rdf')

=== src/plugins/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import os, wscript_helper

csources = [ # generate .so files from c sources that can be loaded by guitarix
    # element = name or [name, [lib, ...]]
    
    ]

sources = [ # generate .so files that can be loaded by guitarix
    #"dunwah.dsp",
    ]

lib_csource_defs = [ # put in static library linked with guitarix
    ["vibe.cc", ("plugin_mono", "plugin_stereo")],
    #"dubbe.cc",
    "abgate.cc",
    "jcm800pre.cpp",
	"reversedelay.cc",
    ]

lib_float_sources = [ # put in static library linked with guitarix
    #"dubber.dsp",
    ]
lib_sources = [ # put in static library linked with guitarix
    "zita_rev1.dsp",
    "ts9sim.dsp",
    "flanger_gx.dsp",
    "mbc.dsp",
    "mbcs.dsp",
    "mbd.dsp",
    "mbe.dsp",
    "mbdel.dsp",
    "mbchor.dsp",
    "gcb_95.dsp",
    "fuzzfacerm.dsp",
    "fuzzfacefm.dsp",
    "hfb.dsp",
    "muff.dsp",
    "susta.dsp",
    "scream.dsp",
    "hornet.dsp",
    "foxeylady.dsp",
    "lpbboost.dsp",
    "hogsfoot.dsp",
    "cstb.dsp",
    "coverd.dsp",
    "rangem.dsp",
    "ruin.dsp",
    "ffreak.dsp",
    "fumaster.dsp",
    "fuzzdrive.dsp",
    "rolandwah.dsp",
    "astrofuzz.dsp",
    "buffb.dsp",
    "eldist.dsp",
    "mole.dsp",
    "buzz.dsp",
    "bfuzz.dsp",
    "axface.dsp",
    ]

def build(bld):
    if bld.env['FAUST']:
        arg, float_arg, double_arg = wscript_helper.get_faust_args(bld)
        arg += ["--init-type=plugin-instance"]
        bld(name = "dsp2cc sharedlib",
            source = sources,
            proc = "../tools/dsp2cc",
            gen_dir_suffix = "/generated",
            proc_args = arg+["--template-type=sharedlib"],
            )
        bld(name = "dsp2cc staticlib",
            source = lib_sources,
            proc = "../tools/dsp2cc",
            gen_dir_suffix = "/generated",
            proc_args = arg+["--template-type=staticlib","--in-namespace=pluginlib"],
            )
        bld(name = "dsp2cc staticlib",
            source = lib_float_sources,
            proc = "../tools/dsp2cc",
            gen_dir_suffix = "/generated",
            proc_args = float_arg+["--template-type=staticlib","--in-namespace=pluginlib","--init-type=plugin-instance"],
            )
    else:
        gdir = "generated/"
        for s in sources+lib_sources:
            s = s.replace(".dsp",".cc")
            bld(name = "copy-faust-plugin-cc",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + s,
                target = s,
            )
    lib_csources = [v if isinstance(v, str) else v[0] for v in lib_csource_defs]
    lib_dict = dict([v for v in lib_csource_defs if not isinstance(v, str)])
    def run(task):
        l = []
        for fname in lib_sources+lib_csources:
            name = os.path.splitext(fname)[0]
            if fname in lib_dict:
                for pname in lib_dict[fname]:
                    l.append("namespace %s { PluginDef *%s(); }\n" % (name, pname))
            else:
                l.append("namespace %s { PluginDef *plugin(); }\n" % name)
        f = open(task.outputs[0].bldpath(task.env),"w")
        f.write('#include "gx_plugin.h"\n\nnamespace pluginlib {\n')
        f.write("".join(l))
        f.write("}\n")
        f.close()
    bld(name = "pluginlib.h",
        source = "wscript",
        rule = run,
        target = "pluginlib.h",
        )
    bld.add_group()
    have_pluginlib = len(lib_sources) != 0
    bld.env["HAVE_PLUGINLIB"] = have_pluginlib
    incl = [".","../headers"]
    if not bld.env['ZITA_RESAMPLER']:
        incl.append('../zita-resampler-1.1.0')
    
    if have_pluginlib:
        bld(features = ['cxx', 'cstaticlib'],
            includes = incl,
            source = [s.replace(".dsp",".cc") for s in lib_sources]+lib_csources,
            uselib = ["EIGEN3"],
            target = "plugins", # (also defines name of task)
            )
    for s in sources:
        tsk = bld(name = "create plugin .so",
            features = ['cxx', 'cshlib'],
            type = 'cshlib',
            cxxflags = ["-fvisibility=hidden"],
            includes = [".","../headers"],
            source = [s.replace(".dsp",".cc")],
            target = s.replace(".dsp",""),
            )
        tsk.env['shlib_PATTERN'] = '%s.so'
    for s in csources:
        if not isinstance(s, str):
            uselib = s[1]
            s = s[0]
        else:
            uselib = []
        tsk = bld(name = "create plugin .so",
            features = ['cxx', 'cshlib'],
            type = 'cshlib',
            cxxflags = ["-fvisibility=hidden"],
            includes = ["../headers"],
            source = s,
            target = s.replace(".cc",""),
            uselib = uselib,
            install_path = None, # for now...
            )
        tsk.env['shlib_PATTERN'] = '%s.so'

def configure(conf):
    conf.check_cfg(package='eigen3', args='--cflags', uselib_store="EIGEN3", mandatory=1)

=== src/LV2/faust/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import wscript_helper
import shutil 

def copy_file(src_fname, dst_fname):

    f = open(src_fname, 'rU')
    txt = f.read()
    f.close()

    f = open(dst_fname, 'w')
    f.write(txt)
    f.close()

def build(bld):
    unused_sources = [
        'preamp.dsp',
        'inputgain.dsp',
        'AntiAlias.dsp',
        'HighShelf.dsp',
        'drive.dsp',
        'osc_tube.dsp',
        'reso_tube.dsp',
        'tube.dsp',
        'tube3.dsp',
        'tubevibrato.dsp',
        'multifilter.dsp',
        'eq.dsp',
        'outputgain.dsp',
        'feed.dsp',
        'balance1.dsp',
        'amp2.dsp',
        'stage3.dsp',
        'distortion.dsp',
        'distortion1.dsp',
        'noisegate.dsp',
        'sloop.dsp', ##float
        'vibe_lfo_triangle.dsp',
        'vibe_mono_lfo_triangle.dsp',
        'presence_level.dsp',
        'cabinet_impulse_former.dsp',
        'preamp_impulse_former.dsp',
        'vibe_mono_lfo_sine.dsp',
        'vibe_lfo_sine.dsp',
        ]
    
    # activate mem allocation internal float
    sources_plugin_float = [
        'echo.dsp',
        'delay.dsp',
        'chorus.dsp',
        'stereodelay.dsp',
        'stereoecho.dsp',
        'phaser_mono.dsp',
        'phaser.dsp',
        'crybaby.dsp',
        ]

    # activate mem allocation internal double
    sources_plugin_init = [
        'gxtubedelay.dsp',
        'gxtubevibrato.dsp',
        'gxechocat.dsp',
        'mbdel.dsp',
        'mbe.dsp',
        
        ]

    sources_plugin = [
        'low_high_pass.dsp',
        'selecteq.dsp',
        'autowah.dsp',
        'gx_distortion.dsp',
        'impulseresponse.dsp',
        'compressor.dsp',
        'expander.dsp',
        'overdrive.dsp',
        'freeverb.dsp',
        'biquad.dsp',
        'tremolo.dsp',
        'chorus_mono.dsp',
        'flanger_mono.dsp',
        'gx_feedback.dsp',
        'flanger.dsp',
        'moog.dsp',
        'gx_ampmodul.dsp',
        'tonecontroll.dsp',
        'stereoverb.dsp',
        'softclip.dsp',
        'gx_ampout.dsp',
        'gx_ampout_ladspa.dsp',
        'noise_shaper.dsp',
        'bassbooster.dsp',
        'gx_outputlevel.dsp',
        'gx_outputlevel_ladspa.dsp',
        'gxfeed.dsp',
        'highbooster.dsp',
        'noiser.dsp',
        'stereo_noiser.dsp',
        'gx_zita_rev1.dsp',
        'gx_flanger.dsp',
        'gxtilttone.dsp',
        'gxtubetremelo.dsp',
        'gx_studiopre.dsp',
        'gx_studiopre_st.dsp',
        'low_high_cut.dsp',
        'uniBar.dsp',
        'mbd.dsp',
        'mbc.dsp',
        'bmfp.dsp',
        'lowpass_up.dsp',
        'lowpass_down.dsp',
        'graphiceq.dsp',
        'duck_delay.dsp',
        'duck_delay_st.dsp',
        'fuzzface.dsp',
        'fuzzfacefm.dsp',
        'hfb.dsp',
        'hornet.dsp',
        'muff.dsp',
        'scream.dsp',
        'susta.dsp',
        'cstb.dsp',
        'fumaster.dsp',
        'hogsfoot.dsp',
        'mole.dsp',
        'rangem.dsp',
        'colwah.dsp',
        'dallaswah.dsp',
        'foxwah.dsp',
        'jenwah.dsp',
        'maestrowah.dsp',
        'selwah.dsp',
        'voxwah.dsp',


        # tone stacks
        'tonestack_default.dsp',
        'tonestack_bassman.dsp',
        'tonestack_twin.dsp',
        'tonestack_princeton.dsp',
        'tonestack_jcm800.dsp',
        'tonestack_jcm2000.dsp',
        'tonestack_mlead.dsp',
        'tonestack_m2199.dsp',
        'tonestack_ac30.dsp',
        'tonestack_soldano.dsp',
        'tonestack_mesa.dsp',
        'tonestack_jtm45.dsp',
        'tonestack_ac15.dsp',
        'tonestack_peavey.dsp',
        'tonestack_ibanez.dsp',
        'tonestack_roland.dsp',
        'tonestack_ampeg.dsp',
        'tonestack_ampeg_rev.dsp',
        'tonestack_sovtek.dsp',
        'tonestack_bogner.dsp',
        'tonestack_groove.dsp',
        'tonestack_crunch.dsp',
        'tonestack_fender_blues.dsp',
        'tonestack_fender_default.dsp',
        'tonestack_fender_deville.dsp',
        'tonestack_gibsen.dsp',

        # tone stacks stereo
        'tonestack_default_stereo.dsp',
        'tonestack_bassman_stereo.dsp',
        'tonestack_twin_stereo.dsp',
        'tonestack_princeton_stereo.dsp',
        'tonestack_jcm800_stereo.dsp',
        'tonestack_jcm2000_stereo.dsp',
        'tonestack_mlead_stereo.dsp',
        'tonestack_m2199_stereo.dsp',
        'tonestack_ac30_stereo.dsp',
        'tonestack_soldano_stereo.dsp',
        'tonestack_mesa_stereo.dsp',
        'tonestack_jtm45_stereo.dsp',
        'tonestack_ac15_stereo.dsp',
        'tonestack_peavey_stereo.dsp',
        'tonestack_ibanez_stereo.dsp',
        'tonestack_roland_stereo.dsp',
        'tonestack_ampeg_stereo.dsp',
        'tonestack_ampeg_rev_stereo.dsp',
        'tonestack_sovtek_stereo.dsp',
        'tonestack_bogner_stereo.dsp',
        'tonestack_groove_stereo.dsp',
        'tonestack_crunch_stereo.dsp',
        'tonestack_fender_blues_stereo.dsp',
        'tonestack_fender_default_stereo.dsp',
        'tonestack_fender_deville_stereo.dsp',
        'tonestack_gibsen_stereo.dsp',

        # amps
        'gxamp.dsp',
        'gxamp2.dsp',
        'gxamp3.dsp',
        'gxamp4.dsp',
        'gxamp5.dsp',
        'gxamp6.dsp',
        'gxamp7.dsp',
        'gxamp8.dsp',
        'gxamp9.dsp',
        'gxamp10.dsp',
        'gxamp11.dsp',
        'gxamp12.dsp',
        'gxamp13.dsp',
        'gxamp14.dsp',
        'gxamp15.dsp',
        'gxamp16.dsp',
        'gxamp17.dsp',
        'gxamp18.dsp',
        'gxnoamp.dsp',
        'gx_chump.dsp',
        'gx_bigchump.dsp',
        'gx_vibrochump.dsp',
        'gxmetal_head.dsp',
        'gxmetal_amp.dsp',

        # stereo amps
        'gxamp_stereo.dsp',
        'gxamp2_stereo.dsp',
        'gxamp3_stereo.dsp',
        'gxamp4_stereo.dsp',
        'gxamp5_stereo.dsp',
        'gxamp6_stereo.dsp',
        'gxamp7_stereo.dsp',
        'gxamp8_stereo.dsp',
        'gxamp9_stereo.dsp',
        'gxamp10_stereo.dsp',
        'gxamp11_stereo.dsp',
        'gxamp12_stereo.dsp',
        'gxamp13_stereo.dsp',
        'gxamp14_stereo.dsp',
        'gxamp15_stereo.dsp',
        'gxamp16_stereo.dsp',
        'gxamp17_stereo.dsp',
        'gxamp18_stereo.dsp',

        # bypass mode
        'balance.dsp',
        ]

    sources_gx_plugin = [

        # 'graphiceq.dsp',
        ]


    if bld.env['FAUST']:
        for x in sources_gx_plugin:
            shutil.copy('src/faust/%s' % x, 'src/LV2/faust/%s' % x)

        arg, float_arg, double_arg = wscript_helper.get_faust_args(bld)
        bld.new_task_gen(
            source = sources_plugin,
            proc = "../tools/dsp2cc",
            proc_args = arg+["--init-type=plugin-lv2"],
            )
        bld.new_task_gen(
            source = sources_gx_plugin,
            proc = "../tools/dsp2cc",
            proc_args = arg+["--init-type=plugin-lv2"],
            )
        bld.new_task_gen(
            source = sources_plugin_init,
            proc = "../tools/dsp2cc",
            proc_args = arg+["-s","40000","--init-type=plugin-lv2"],
            )
        bld.new_task_gen(
            source = sources_plugin_float,
            proc = "../tools/dsp2cc",
            proc_args = float_arg+["--init-type=plugin-lv2"]
            )
    else:
        gdir = "../faust-generated/"
        for s in sources_plugin_float + sources_plugin + sources_plugin_init:
            s = s.replace(".dsp",".cc")
            bld(name = "copy-faust-cc",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + s,
                target = s,
                )
    bld.add_group()

def configure(conf):
    pass

=== src/LV2/gx_amp.lv2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import sys, os, TaskGen, ctypes, wscript_helper

def configure(conf):
    pass

def build(bld):
    bundle = 'gx_amp.lv2'
    
    src = ['gxamp.cpp',
           'gx_amp.cc',
           'gx_tonestack.cc',
           '../DSP/gx_resampler.cc',
           '../DSP/gx_convolver.cc'
           ]
    incl = ['../faust','./', '../DSP', '../DSP/tube_tables']
    lib = []
    if sys.platform.startswith("linux"):
        lib.append('dl')
    uselib = ['LV2CORE','GLIBMM']
    if not bld.env['ZITA_CONVOLVER']:
        if not bld.env['CONVOLVER_FFMPEG']:
            uselib.append('FFTW3')
    wscript_helper.add_zita_convolver(bld, uselib, src, incl, base="../..")
    wscript_helper.add_zita_resampler(bld, uselib, src, incl, base="../..")
    cxxflag =[]
    ldscript = bld.path.find_resource('gx_amp.lds')
    mapfile = bld.path.find_or_declare("gx_amp.map")
    if not bld.env['OPT'] and bld.env['SSE2']:
        cxxflag = [ "-msse2", "-mfpmath=sse"]
    lv2_plugin = bld(
        features='cxx cshlib ',
        includes = incl,
        lib = lib,
        uselib = uselib,
        obj_ext  = '_8.o',
        cxxflags = cxxflag,
        defines  = ["LV2_SO"],
        target   = 'gx_amp',
        source   = src,
        install_path = '${LV2DIR}/%s' % bundle,
        chmod = 0o755,
        ldflags = ['-Wl,%s,-Map=%s' % (ldscript.srcpath(),mapfile.bldpath(bld.env))],
        )
    bld.add_manual_dependency(bld.path.find_or_declare(lv2_plugin.target), ldscript)
    lv2_plugin.env['shlib_PATTERN'] = '%s.so'
    
    if not bld.env['NOLV2GUI']:
        uselib_local1 = []
        libpath1 = []
        lib1 = []
        incl = ['../../../libgxwmm','../../../libgxw']
        if sys.platform.startswith("linux"):
            lib1.append('dl')
        if bld.env["GX_LIB_SHARED"]:
            lib1 += ['gxwmm','gxw']
            libpath1 += [bld.path.find_dir("../../../libgxw/gxw").bldpath(bld.env),
                        bld.path.find_dir("../../../libgxwmm/gxwmm").bldpath(bld.env)]
        else:
            uselib_local1 += ['gxwmm','gxw']
        
        lv2_plugin_gui = bld(
            features='cxx cshlib ',
            includes = incl,
            lib = lib1,
            uselib = 'LV2CORE GTKMM',
            libpath = libpath1,
            uselib_local = uselib_local1,
            linkflags = '-Wl,-z,nodelete',
            defines  = ["LV2_GUI"],
            target   = 'gx_amp_gui',
            source   = 'widget.cpp gxamp_gui.cpp',
            install_path = '${LV2DIR}/%s' % bundle,
            chmod = 0o755,
            )
        lv2_plugin_gui.env['shlib_PATTERN'] = '%s.so'

    
    install_path = '${LV2DIR}/%s' % bundle,
    bld.install_files('${LV2DIR}/gx_amp.lv2', 'manifest.ttl')
    bld.install_files('${LV2DIR}/gx_amp.lv2', 'gx_amp.ttl')
    bld.install_files('${LV2DIR}/gx_amp.lv2', 'modgui.ttl')

    bld.install_files('${LV2DIR}/gx_amp.lv2/', bld.path.ant_glob('modgui/**/*'), relative_trick=True)

=== src/LV2/gx_amp_stereo.lv2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import sys, os, TaskGen, ctypes, wscript_helper

def configure(conf):
    pass

def build(bld):
    bundle = 'gx_amp_stereo.lv2'
    
    src = ['gxamp_stereo.cpp',
           'gx_amp_stereo.cc',
           'gx_tonestack_stereo.cc',
           '../DSP/gx_resampler.cc',
           '../DSP/gx_convolver.cc'
           ]
    incl = ['../faust','./', '../DSP', '../DSP/tube_tables']
    lib = []
    if sys.platform.startswith("linux"):
        lib.append('dl')
    uselib = ['LV2CORE','GLIBMM']
    if not bld.env['ZITA_CONVOLVER']:
        if not bld.env['CONVOLVER_FFMPEG']:
            uselib.append('FFTW3')
    wscript_helper.add_zita_convolver(bld, uselib, src, incl, base="../..")
    wscript_helper.add_zita_resampler(bld, uselib, src, incl, base="../..")
    cxxflag =[]
    ldscript = bld.path.find_resource('gxamp_stereo.lds')
    mapfile = bld.path.find_or_declare("gxamp_stereo.map")
    if not bld.env['OPT'] and bld.env['SSE2']:
        cxxflag = [ "-msse2", "-mfpmath=sse"]
    lv2_plugin = bld(
        features='cxx cshlib ',
        includes = incl,
        lib = lib,
        uselib = uselib,
        obj_ext  = '_13.o',
        cxxflags = cxxflag,
        defines  = ["LV2_SO"],
        target   = 'gx_amp_stereo',
        source   = src,
        install_path = '${LV2DIR}/%s' % bundle,
        chmod = 0o755,
        ldflags = ['-Wl,%s,-Map=%s' % (ldscript.srcpath(),mapfile.bldpath(bld.env))],
        )
    bld.add_manual_dependency(bld.path.find_or_declare(lv2_plugin.target), ldscript)
    lv2_plugin.env['shlib_PATTERN'] = '%s.so'
    
    if not bld.env['NOLV2GUI']:
        uselib_local1 = []
        libpath1 = []
        lib1 = []
        incl = ['../../../libgxwmm','../../../libgxw']
        if sys.platform.startswith("linux"):
            lib1.append('dl')
        if bld.env["GX_LIB_SHARED"]:
            lib1 += ['gxwmm','gxw']
            libpath1 += [bld.path.find_dir("../../../libgxw/gxw").bldpath(bld.env),
                        bld.path.find_dir("../../../libgxwmm/gxwmm").bldpath(bld.env)]
        else:
            uselib_local1 += ['gxwmm','gxw']
        
        lv2_plugin_gui = bld(
            features='cxx cshlib ',
            includes = incl,
            lib = lib1,
            uselib = 'LV2CORE GTKMM',
            libpath = libpath1,
            uselib_local = uselib_local1,
            linkflags = '-Wl,-z,nodelete',
            defines  = ["LV2_GUI"],
            target   = 'gx_amp_stereo_gui',
            source   = 'widget_stereo.cpp gxamp_stereo_gui.cpp',
            install_path = '${LV2DIR}/%s' % bundle,
            chmod = 0o755,
            )
        lv2_plugin_gui.env['shlib_PATTERN'] = '%s.so'

    
    install_path = '${LV2DIR}/%s' % bundle,
    bld.install_files('${LV2DIR}/gx_amp_stereo.lv2', 'manifest.ttl')
    bld.install_files('${LV2DIR}/gx_amp_stereo.lv2', 'gx_amp_stereo.ttl')

    bld.install_files('${LV2DIR}/gx_amp_stereo.lv2/', bld.path.ant_glob('modgui/**/*'), relative_trick=True)

=== src/LV2/gx_barkgraphiceq.lv2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import sys, os, TaskGen, ctypes

def configure(conf):
    pass

def build(bld):
    bundle = 'gx_barkgraphiceq.lv2'
    
    src = ['gx_barkgraphiceq.cpp'
           ]
    incl = ['../faust', './', '../DSP','../../headers']
    lib = []
    if sys.platform.startswith("linux"):
        lib.append('dl')
    uselib = ['LV2CORE']
    cxxflag =[]
    if not bld.env['OPT'] and bld.env['SSE2']:
        cxxflag = [ "-msse2", "-mfpmath=sse"]
    lv2_effects = bld(
        features='cxx cshlib ',
        includes = incl,
        lib = lib,
        uselib = uselib,
        obj_ext  = '_14.o',
        cxxflags = cxxflag,
        defines  = ["LV2_SO"],
        target   = 'gx_barkgraphiceq',
        source   = src,
        install_path = '${LV2DIR}/%s' % bundle,
        chmod = 0o755,
        )
    lv2_effects.env['shlib_PATTERN'] = '%s.so'
    
    if not bld.env['NOLV2GUI']:
        uselib_local5 = []
        libpath5 = []
        lib5 = []
        incl5 = ['../../../libgxwmm','../../../libgxw','../']
        if sys.platform.startswith("linux"):
            lib5.append('dl')
        if bld.env["GX_LIB_SHARED"]:
            lib5 += ['gxwmm','gxw']
            libpath5 += [bld.path.find_dir("../../../libgxw/gxw").bldpath(bld.env),
                        bld.path.find_dir("../../../libgxwmm/gxwmm").bldpath(bld.env)]
        else:
            uselib_local5 += ['gxwmm','gxw']
        
        lv2_effetcs_gui = bld(
            features='cxx cshlib ',
            includes = incl5,
            lib = lib5,
            uselib = 'LV2CORE GTKMM',
            libpath = libpath5,
            uselib_local = uselib_local5,
            linkflags = '-Wl,-z,nodelete',
            defines  = ["LV2_GUI"],
            target   = 'gx_barkgraphiceq_gui',
            source   = 'widget.cpp gx_barkgraphiceq_gui.cpp',
            install_path = '${LV2DIR}/%s' % bundle,
            chmod = 0o755,
            )
        lv2_effetcs_gui.env['shlib_PATTERN'] = '%s.so'

    
    install_path = '${LV2DIR}/%s' % bundle,
    bld.install_files('${LV2DIR}/gx_barkgraphiceq.lv2', 'manifest.ttl')
    bld.install_files('${LV2DIR}/gx_barkgraphiceq.lv2', 'gx_barkgraphiceq.ttl')

    bld.install_files('${LV2DIR}/gx_barkgraphiceq.lv2/', bld.path.ant_glob('modgui/**/*'), relative_trick=True)

=== debian/changelog ===
guitarix (0.34.0-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.
    - Fix FTBFS by using correct flags when compiling against C++11
      (Closes: #805666).
    - Fix segfault when adding LADSPA plugin to a category with accents
      in the name (Closes: #788564).
  * debian/source/include-binaries: remove as not needed anymore.
  * debian/patch: update patchs to new version.
  * debian/control: Build-Depends: add libwebkit-dev.
  * Update manpage to new version.
  * source.lintian-overrides: remove as not needed anymore.

 -- Víctor Cuadrado Juan <me@viccuad.me>  Sun, 20 Dec 2015 21:03:15 +0100

=== debian/control ===
Source: guitarix
Section: sound
Priority: extra
Maintainer: Roland Stigge <stigge@antcom.de>
Build-Depends: debhelper (>= 9), python, libjack-dev, libsndfile1-dev, libgtk2.0-dev, ladspa-sdk, libzita-convolver-dev, libgtkmm-2.4-dev, libboost-dev (>= 1.53), libboost-thread-dev (>= 1.53), intltool, liblrdf0-dev, libboost-system-dev (>= 1.53), lv2-dev, libavahi-gobject-dev, libeigen3-dev, libzita-resampler-dev, libbluetooth-dev [linux-any], liblilv-dev, libwebkit-dev
Standards-Version: 3.9.6
Homepage: http://guitarix.sourceforge.net/

Package: guitarix
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gtk2-engines, gtk2-engines-pixbuf
Recommends: jack-capture, vorbis-tools, lame
Description: Rock guitar amplifier for Jack
 Guitarix is a rock guitar amplifier for Jack (Jack Audio Connection Kit) with
 one input and two outputs. It is designed to get nice trash/metal/rock/guitar
 sounds.  Controls are available for bass, treble, gain, balance, distortion,
 freeverb, crybaby(wah) and echo. For the 'pressure' in the sound you can use
 the feedback and feedforward sliders. guitarix comes with a GTK+ interface and
 as Ladspa plugin.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	./waf configure --prefix=/usr --no-faust \
		--cxxflags="$(shell dpkg-buildflags --get CXXFLAGS) \
			$(shell dpkg-buildflags --get CPPFLAGS)" \
		--ldflags="$(shell dpkg-buildflags --get LDFLAGS)" -v

override_dh_auto_build:
	./waf build -v

override_dh_auto_clean: 
	./waf distclean
	rm -rf build/*
	rm -rf build/.conf*
	rm -rf build/.waf*
	find . -name "*.pyc" -delete

override_dh_auto_install:
	./waf install --destdir=$(CURDIR)/debian/guitarix
	rm -f $(CURDIR)/debian/guitarix/usr/share/gx_head/sounds/bands/LICENSE
	rm -f $(CURDIR)/debian/guitarix/usr/share/gx_head/sounds/amps/LICENSE
	rm -f $(CURDIR)/debian/guitarix/usr/lib/libgxw.so
	rm -f $(CURDIR)/debian/guitarix/usr/lib/libgxwmm.so

=== debian/watch ===
version=3
http://qa.debian.org/watch/sf.php/guitarix/ \
(?:|.*/)guitarix2(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
